# Post Data Transaction

#### URL Endpoint Post Data

The endpoint URL is a feedback URL that will process the data in the post from the merchant system. For the implementation of the testing, UAT can use URL development.

<table><thead><tr><th width="99">Type</th><th width="139">Environment</th><th>URL</th></tr></thead><tbody><tr><td>XML</td><td>Development</td><td><a href="https://debit-sandbox.faspay.co.id/pws/300011/183xx00010100000">https://debit-sandbox.faspay.co.id/pws/300011/183xx00010100000</a></td></tr><tr><td>JSON</td><td>Development</td><td><a href="https://debit-sandbox.faspay.co.id/cvr/300011/10">https://debit-sandbox.faspay.co.id/cvr/300011/10</a></td></tr></tbody></table>

## Request Parameter

The parameter that must be provide by the Merchant system to be accessed by the Faspay system are as follows:

<table><thead><tr><th width="350">Parameter</th><th width="203">Data Type</th><th width="83">M/O/C</th><th width="304">Decription</th></tr></thead><tbody><tr><td><p> </p><p>request</p><p> </p></td><td>Alphanumeric (50)</td><td>M</td><td>Request Description</td></tr><tr><td><p> </p><p>merchant_id</p><p> </p></td><td>Numeric (5)</td><td>M</td><td>Merchant Code From Faspay = BOI</td></tr><tr><td><p> </p><p>merchant</p><p> </p></td><td>Alphanumeric (32)</td><td>M</td><td>Merchant Name</td></tr><tr><td><p> </p><p>bill_no</p><p> </p></td><td>Alphanumeric (32)</td><td>M</td><td>Order Number</td></tr><tr><td><p> </p><p>bill_reff</p><p> </p></td><td>Alphanumeric (32)</td><td>O</td><td>Booking Number/reference (can fill same with order no)</td></tr><tr><td><p> </p><p>bill_date</p><p> </p></td><td>Datetime YYYY-MM-DD HH:MM:SS (19)</td><td>M</td><td>Transaction/ Order Date</td></tr><tr><td><p> </p><p>bill_expired</p><p> </p></td><td>Datetime YYYY-MM-DD HH:MM:SS (19)</td><td>M</td><td>Payment Expiring Date (max 30 days)</td></tr><tr><td><p> </p><p>bill_desc</p><p> </p></td><td>Alphanumeric (128)</td><td>M</td><td>Transaction Description</td></tr><tr><td><p> </p><p>bill_currency</p><p> </p></td><td>Alphanumeric (3)</td><td>M</td><td>Currency, Must be 'IDR'</td></tr><tr><td><p> </p><p>bill_gross</p><p> </p></td><td>Numeric (15)</td><td>O</td><td>Order Nominal</td></tr><tr><td><p> </p><p>bill_tax</p><p> </p></td><td>Numeric (15)</td><td>O</td><td>Billing tax</td></tr><tr><td><p> </p><p>bill_miscfee</p><p> </p></td><td>Numeric (15)</td><td>O</td><td>Miscellaneous fee</td></tr><tr><td><p> </p><p>bill_total</p><p> </p></td><td>Numeric (15)</td><td>M</td><td>Total Nominal</td></tr><tr><td><p> </p><p>cust_no</p><p> </p></td><td>Alphanumeric (32)</td><td>M</td><td>Customer Number</td></tr><tr><td><p> </p><p>cust_name</p><p> </p></td><td>Alphanumeric (128)</td><td>M</td><td>Customer Name</td></tr><tr><td><p> </p><p>cust_lastname</p><p> </p></td><td>Alphanumeric (128)</td><td>O</td><td>Customer Last name</td></tr><tr><td><p> </p><p>payment_channel</p><p> </p></td><td>Numeric (3)</td><td>M</td><td>Payment channel<br>In details <a href="https://docs.faspay.co.id/merchant-integration/api-reference-1/debit-transaction/reference/payment-channel-code#list-of-payment-channel-code">here.</a></td></tr><tr><td><p> </p><p>pay_type</p><p> </p></td><td>Alphanumeric (1)</td><td>M</td><td><p>Payment type :</p><ul><li>1: Full Settlement</li><li>2: Installment</li><li>3: Mixed 1 &#x26; 2</li></ul><p>Pay Type 2 &#x26; 3 only implement on BCA KlikPay channel</p><p> </p></td></tr><tr><td><p> </p><p>bank_userid</p><p> </p></td><td>Alphanumeric (128)</td><td>O</td><td>Customer User ID on bank’s services</td></tr><tr><td><p> </p><p>msisdn</p><p> </p></td><td>Numeric (64)</td><td>M</td><td>Customer Mobile Phone</td></tr><tr><td><p> </p><p>email</p><p> </p></td><td>Alphanumeric (128)</td><td>M</td><td>Customer Email</td></tr><tr><td><p> </p><p>terminal</p><p> </p></td><td>Numeric (16)</td><td>M</td><td>Always use 10 for Terminal</td></tr><tr><td><p> </p><p>billing_name</p><p> </p></td><td>Alphanumeric</td><td>C</td><td>Billing name for OVO</td></tr><tr><td><p> </p><p>billing_lastname</p><p> </p></td><td>Billing name</td><td>O</td><td>biling last name</td></tr><tr><td><p> </p><p>billing_address</p><p> </p></td><td>Alphanumeric (200)</td><td>O</td><td>Billing address</td></tr><tr><td><p> </p><p>billing_address_city</p><p> </p></td><td>Alphanumeric (50)</td><td>O</td><td>Billing City</td></tr><tr><td><p> </p><p>billing_address_region</p><p> </p></td><td>Alphanumeric (100)</td><td>O</td><td>Billing Addres Region</td></tr><tr><td><p> </p><p>billing_address_state</p><p> </p></td><td>Alphanumeric (100)</td><td>O</td><td>Billing Address State</td></tr><tr><td><p> </p><p>billing_address_poscode</p><p> </p></td><td>Alphanumeric (10)</td><td>O</td><td>Billing Address Pos Code</td></tr><tr><td><p> </p><p>billing_msisdn</p><p> </p></td><td>Numeric</td><td>C</td><td>Billing phone number</td></tr><tr><td><p> </p><p>billing_address_country_code</p><p> </p></td><td>Alphanumeric (10)</td><td>O</td><td>Billing Address Country Code</td></tr><tr><td><p> </p><p>receiver_name_for_shipping</p><p> </p></td><td>Alphanumeric (100)</td><td>C</td><td>Receiver Name</td></tr><tr><td><p> </p><p>shipping_lastname</p><p> </p></td><td>Alphanumeric</td><td>O</td><td>Receiver last name</td></tr><tr><td><p> </p><p>shipping_address</p><p> </p></td><td>Alphanumeric (200)</td><td>O</td><td>Shipping Address</td></tr><tr><td><p> </p><p>shipping_address_city</p><p> </p></td><td>Alphanumeric (50)</td><td>O</td><td>Shipping Address City</td></tr><tr><td><p> </p><p>shipping_address_region</p><p> </p></td><td>Alphanumeric (100)</td><td>O</td><td>Shipping Address Region</td></tr><tr><td><p> </p><p>shipping_address_state</p><p> </p></td><td>Alphanumeric (100)</td><td>O</td><td>Shipping Address State</td></tr><tr><td><p> </p><p>shipping_address_poscode</p><p> </p></td><td>Alphanumeric (10)</td><td>O</td><td>Shipping Address Pos Code</td></tr><tr><td><p> </p><p>shipping_msisdn</p><p> </p></td><td>Numeric</td><td>C</td><td>Shipping phone number</td></tr><tr><td><p> </p><p>shipping_address_country_code</p><p> </p></td><td>Alphanumeric (10)</td><td>O</td><td>Shipping Address Country Code</td></tr><tr><td><p> </p><p>item </p><p> </p></td><td>Array of Object</td><td>C</td><td><p>Item details</p><p></p><p><strong>Notes:</strong></p><ul><li>Variable that contains in this parameter are <strong>customizeable, except Amount</strong></li><li>This parameter is <strong>Mandatory for</strong> payment channel <strong>Akulaku, DanaSubs, Kredivo</strong> and <strong>BRICeria</strong></li></ul></td></tr><tr><td><p> </p><p>        product</p><p> </p></td><td>Alphanumeric (50)</td><td>C</td><td>Item name</td></tr><tr><td><p> </p><p>        qty</p><p> </p></td><td>Numeric (32)</td><td>C</td><td>Item quantity</td></tr><tr><td><p> </p><p>       amount</p><p> </p></td><td>Numeric (15)</td><td>C</td><td>Item Price</td></tr><tr><td><p> </p><p>       tenor</p><p> </p></td><td>Numeric (2)</td><td>C</td><td><p>Installment Tenor</p><ul><li>00: Full Payment</li><li>03: 3 months</li><li>6 months</li><li>12: 12 months</li></ul><p>Tenor 03,06,12 only use on BCA KlikPay channel</p></td></tr><tr><td><p> </p><p>       payment_plan</p><p> </p></td><td>Numeric (1)</td><td>C</td><td><p>Payment plan</p><ul><li>1: Full Settlement</li><li>2: Installement</li></ul><p> </p></td></tr><tr><td><p> </p><p>       merchant_id</p><p> </p></td><td>Numeric (5)</td><td>C</td><td>Merchant Id From Payment Channel ex : MID from BCA KlikPay</td></tr><tr><td><p> </p><p>reserve1</p><p> </p></td><td>Alphanumeric (50)</td><td>O</td><td> </td></tr><tr><td><p> </p><p>reserve2</p><p> </p></td><td>Alphanumeric (50)</td><td>C</td><td> </td></tr><tr><td><p> </p><p>route</p><p> </p></td><td>Object</td><td>O</td><td> </td></tr><tr><td><p> </p><p>        owner</p><p> </p></td><td>Alphanumeric (32) </td><td>O</td><td><p>Registered partner id that owns/generates the transaction. </p><p> </p><p><strong>Notes:</strong></p><ul><li>1 transaction only can contain 1 owner. </li><li>If null, then the remaining transaction amount will belong to the merchant’s Sendme balance. </li></ul></td></tr><tr><td><p> </p><p>       partner_id</p><p> </p></td><td>Alphanumeric (32) </td><td>O</td><td>Merchant partner id number.</td></tr><tr><td><p> </p><p>      partner_amount</p><p> </p></td><td>Numeric (15) </td><td>C</td><td>Disbursement amount to partner.  </td></tr><tr><td><p> </p><p>signature</p><p> </p></td><td>Alphanumeric (100)</td><td>M</td><td><p>sha1(md5(user_id merchant + password merchant + bill_no))</p><ul><li>$signature : sha1(md5(($user_id.$pass.$bill_no)));</li><li>Sample signature: sha1(md5("bot310001p@ssw0rd310001zx")) = e0ba1b2dc29ab4cb4221df092f44b1c4e6f45c63</li></ul></td></tr></tbody></table>

***

### Sample Request

{% tabs %}
{% tab title="Sample Request (JSON)" %}

```json
{
    "request": "Payment Details",
    "merchant_id": "99999",
    "merchant": "FASPAY STORE",
    "bill_no": "9333300199999123456",
    "bill_reff": "Abcd",
    "bill_date": "2024-09-11 10:00:00",
    "bill_expired": "2024-09-12 14:36:32",
    "bill_desc": "Gadget payment",
    "bill_currency": "IDR",
    "bill_gross": "0",
    "bill_tax": "0",
    "bill_miscfee": "0",
    "bill_total": "1000000",
    "cust_no": "1",
    "cust_name": "budi",
    "cust_lastname": "faspay",
    "payment_channel": "402",
    "pay_type": "1",
    "bank_userid": "",
    "msisdn": "08123123123",
    "email": "budi@gmail.com",
    "terminal": "10",
    "billing_name": "faspay",
    "billing_lastname": "0",
    "billing_address": "jalan pintu air raya",
    "billing_address_city": "Jakarta Pusat",
    "billing_address_region": "DKI Jakarta",
    "billing_address_state": "Indonesia",
    "billing_address_poscode": "10710",
    "billing_msisdn": "8766688686",
    "billing_address_country_code": "ID",
    "receiver_name_for_shipping": "Faspay",
    "shipping_lastname": "",
    "shipping_address": "jalan pintu air raya",
    "shipping_address_city": "Jakarta Pusat",
    "shipping_address_region": "DKI Jakarta",
    "shipping_address_state": "Indonesia",
    "shipping_address_poscode": "10710",
    "shipping_msisdn": "8766688686",
    "shipping_address_country_code": "ID",
    "item":
    [
        {
            "product": "Invoice",
            "qty": 1,
            "amount": 1000000,
            "tenor": 0,
            "payment_plan": 1,
            "merchant_id": "99999"
        }
    ],
    "reserve1": "0",
    "reserve2": "",
    "route":
    [
        {
            "owner": "26100253"
        },
        {
            "partner_id": "29195827",
            "partner_amount": "500000"
        },
        {
            "partner_id": "29200008",
            "partner_amount": "500000"
        }
    ],
    "signature": "ca1ed7300c72b8b14bc503826d0f54db8ed1a8b8"
}

```

{% endtab %}

{% tab title="Sample Request (XML)" %}

```xml
<?xml version="1.0" encoding="UTF-8" ?>
 <faspay>
     <request>Payment Details</request>
     <merchant_id>99999</merchant_id>
     <merchant>FASPAY STORE</merchant>
     <bill_no>9333300199999123456</bill_no>
     <bill_reff>Abcd</bill_reff>
     <bill_date>2024-09-11 10:00:00</bill_date>
     <bill_expired>2024-09-12 14:36:32</bill_expired>
     <bill_desc>Gadget payment</bill_desc>
     <bill_currency>IDR</bill_currency>
     <bill_gross>0</bill_gross>
     <bill_tax>0</bill_tax>
     <bill_miscfee>0</bill_miscfee>
     <bill_total>1000000</bill_total>
     <cust_no>1</cust_no>
     <cust_name>budi</cust_name>
     <cust_lastname>faspay</cust_lastname>
     <payment_channel>402</payment_channel>
     <pay_type>1</pay_type>
     <bank_userid></bank_userid>
     <msisdn>08123123123</msisdn>
     <email>budi@gmail.com</email>
     <terminal>10</terminal>
     <billing_name>faspay</billing_name>
     <billing_lastname>0</billing_lastname>
     <billing_address>jalan pintu air raya</billing_address>
     <billing_address_city>Jakarta Pusat</billing_address_city>
     <billing_address_region>DKI Jakarta</billing_address_region>
     <billing_address_state>Indonesia</billing_address_state>
     <billing_address_poscode>10710</billing_address_poscode>
     <billing_msisdn>8766688686</billing_msisdn>
     <billing_address_country_code>ID</billing_address_country_code>
     <receiver_name_for_shipping>Faspay</receiver_name_for_shipping>
     <shipping_lastname></shipping_lastname>
     <shipping_address>jalan pintu air raya</shipping_address>
     <shipping_address_city>Jakarta Pusat</shipping_address_city>
     <shipping_address_region>DKI Jakarta</shipping_address_region>
     <shipping_address_state>Indonesia</shipping_address_state>
     <shipping_address_poscode>10710</shipping_address_poscode>
     <shipping_msisdn>8766688686</shipping_msisdn>
     <shipping_address_country_code>ID</shipping_address_country_code>
     <item>
         <product>Invoice</product>
         <qty>1</qty>
         <amount>1000000</amount>
         <tenor>0</tenor>
         <payment_plan>1</payment_plan>
         <merchant_id>99999</merchant_id>
     </item>
     <reserve1>0</reserve1>
     <reserve2></reserve2>
     <route>
         <owner>26100253</owner>
     </route>
     <route>
         <partner_id>29195827</partner_id>
         <partner_amount>500000</partner_amount>
     </route>
     <route>
         <partner_id>29200008</partner_id>
         <partner_amount>500000</partner_amount>
     </route>
     <signature>ca1ed7300c72b8b14bc503826d0f54db8ed1a8b8</signature>
 </faspay>

```

{% endtab %}
{% endtabs %}

## Response Parameter

Response parameters are parameters that will be delivered by Faspay system in response to the request that have been sent by the merchant system. If no parameters appropriate/value are incorrect, the transaction will be rejected in the system Faspay.

<table><thead><tr><th width="299">Parameter</th><th width="155">Data Type</th><th width="85">M/O/C</th><th>Description</th></tr></thead><tbody><tr><td>response</td><td>Alphanumeric (50)</td><td>O</td><td>Response Name</td></tr><tr><td>trx_id</td><td>Numeric (16)</td><td>M</td><td><p>Transaction ID (Issued/generated by Faspay)</p><p> </p><p>Notes: Unique Transaction ID for 1 day or if it hasn't been paid and hasn't expired</p></td></tr><tr><td>merchant_id</td><td>Numeric (5)</td><td>M</td><td>Merchant Code</td></tr><tr><td>merchant</td><td>Alphanumeric (32)</td><td>M</td><td>Merchant Name</td></tr><tr><td>bill_no</td><td>Alphanumeric (32)</td><td>M</td><td>Order No</td></tr><tr><td>external_id</td><td>Alphanumeric (16)</td><td>C</td><td>External id number</td></tr><tr><td>bill_item </td><td>Array of Object</td><td>C</td><td><p>Details item</p><p> </p><p><strong>Notes:</strong></p><ul><li>Variable that contains in this parameter are <strong>customizable, except Amount</strong></li><li>This parameter is <strong>Mandatory for</strong> payment channel <strong>Akulaku, DanaSubs, Kredivo</strong> and <strong>BRICeria</strong></li></ul></td></tr><tr><td>    product</td><td>Alphanumeric (50)</td><td>C</td><td>Item name</td></tr><tr><td>    qty</td><td>Numeric (32)</td><td>C</td><td>Item quantity</td></tr><tr><td>   amount</td><td>Numeric (15)</td><td>C</td><td>Item Price</td></tr><tr><td>   tenor</td><td>Numeric (2)</td><td>C</td><td><p>Installment Tenor</p><ul><li>00: Full Payment</li><li> 03: 3 months</li><li>06: 6 months</li><li>12: 12 months</li></ul><p>Tenor 03,06,12 only use on BCA KlikPay channel</p></td></tr><tr><td>   payment_plan</td><td>Numeric (1)</td><td>C</td><td><p>Payment plan</p><ul><li> 1: Full Settlement</li><li>2: Installment</li></ul><p> </p></td></tr><tr><td>   merchant_id</td><td>Numeric (5)</td><td>C</td><td><p>Merchant Id From Payment Channel </p><p><strong>example:</strong> MID from BCA KlikPay</p></td></tr><tr><td>response_code</td><td>Numeric (2)</td><td>M</td><td>Response Code. In details <a href="https://docs.faspay.co.id/merchant-integration/api-reference-1/debit-transaction/reference/status-response-code">here.</a></td></tr><tr><td>response_desc</td><td>Alphanumeric (32)</td><td>M</td><td>Response Code Description. In details <a href="https://docs.faspay.co.id/merchant-integration/api-reference-1/debit-transaction/reference/status-response-code">here.</a></td></tr><tr><td>route</td><td>Object</td><td>O</td><td> </td></tr><tr><td>    owner</td><td>Alphanumeric (32) </td><td>O</td><td><p>Registered partner id that owns/generates the transaction. </p><p> </p><p><strong>Notes:</strong></p><ul><li> 1 transaction only can contain 1 owner. </li><li>If null, then the remaining transaction amount will belong to the merchant’s Sendme balance. </li></ul></td></tr><tr><td>    partner_id</td><td>Alphanumeric (32) </td><td>O</td><td>Merchant partner id number.</td></tr><tr><td>    partner_amount</td><td>Numeric (15) </td><td>C</td><td>Disbursement amount to partner.  </td></tr><tr><td>redirect_url</td><td>Alphanumeric</td><td>O</td><td>The redirect URL for the next process, available only on JSON format</td></tr></tbody></table>

### Sample Response

{% tabs %}
{% tab title="Sample Response (JSON)" %}

```json
{
    "response": "Payment Details",
    "trx_id": "8504999946414145",
    "merchant_id": "99999",
    "merchant": "FASPAY",
    "bill_no": "9333300199999123456",
    "external_id": "",
    "bill_item": [
        {
            "product": "Invoice",
            "qty": 1,
            "amount": 1000000,
            "tenor": 0,
            "payment_plan": 1,
            "merchant_id": "99999"
        }
    ],
    "response_code": "00",
    "response_desc": "Success",
    "route":
    [
        {
            "owner": "26100253"
        },
        {
            "partner_id": "29195827",
            "partner_amount": "500000"
        },
        {
            "partner_id": "29200008",
            "partner_amount": "500000"
        }
    ],
    "redirect_url": "https://debit-staging.faspay.co.id/pws/100003/0830000010100000/ca1ed7300c72b8b14bc503826d0f54db8ed1a8b8?trx_id=8504999946414145&merchant_id=99999&bill_no=9333300199999123456"
}

```

{% endtab %}

{% tab title="Sample Response (XML)" %}

```xml
<?xml version="1.0" encoding="UTF-8" ?>
 <faspay>
     <response>Payment Details</response>
     <trx_id>8504999946414145</trx_id>
     <merchant_id>99999</merchant_id>
     <merchant>FASPAY</merchant>
     <bill_no>9333300199999123456</bill_no>
     <external_id></external_id>
     <bill_item>
         <product>Invoice</product>
         <qty>1</qty>
         <amount>1000000</amount>
         <tenor>0</tenor>
         <payment_plan>1</payment_plan>
         <merchant_id>99999</merchant_id>
     </bill_item>
     <response_code>00</response_code>
     <response_desc>Sukses</response_desc>
     <route>
         <owner>26100253</owner>
     </route>
     <route>
         <partner_id>29195827</partner_id>
         <partner_amount>500000</partner_amount>
     </route>
     <route>
         <partner_id>29200008</partner_id>
         <partner_amount>500000</partner_amount>
     </route>
     <redirect_url>https://debit-staging.faspay.co.id/pws/100003/0830000010100000/ca1ed7300c72b8b14bc503826d0f54db8ed1a8b8?trx_id=8504999946414145&merchant_id=99999&bill_no=9333300199999123456</redirect_url>
 </faspay>

```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.faspay.co.id/merchant-integration/api-reference-1/route-payment/post-data-transaction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
